

        
#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm




#define ADC_VREF_TYPE 0x00

#define MAX_DEVICES 8
#define SHIM_1 125

#define KEY_MENU PINC.3
#define KEY_UP PINC.2
#define KEY_DOWN PINC.6
#define KEY_LEFT PINC.5
#define KEY_RIGHT PINC.4
#define TIME_ANTIDREB 100
#define DELAY_KEY_PRESSED 50

#define LEG_IGNITION PIND.4
#define LEG_LIGHT PINC.1
#define PIN_DRL PORTB.0

#define K_SRED_OST_KM 60   
#define K_SRED_DL_VPR 100
#define DRL_SPEED 20
//   

#define DISP_MENU 110
#define DISP_MAIN_1 101
#define DISP_MAIN_2 102
#define DISP_MAIN_3 103

#define PUNKTOV_MENU 11    //  
#define DISP_NUMBER_MIN 10
#define DISP_NUMBER_MAX 21

#define DISP_ZAPRAVKA 10
#define DISP_RST_COUNTERS 11
#define DISP_SERVIS 12
#define DISP_OIL 13
#define DISP_GRM 14
#define DISP_FORS 15
#define DISP_SPEED 16
#define DISP_CONTRAST 17
#define DISP_BRIGHTNESS 18
#define RST_DEFAULT 19
#define DISP_ABOUT  20
#define DISP_DEBAG 21


                 
    
 
eeprom char eeprom_display_contrast = 51;
eeprom char eeprom_display_brightness = 51; 
eeprom char eeprom_no_first_start;
eeprom unsigned long int  eeprom_v_bake;
eeprom unsigned int  eeprom_imp_km; 
eeprom float eeprom_PrFors;  //  4 
eeprom unsigned long int eeprom_do_zameny_grm_imp;
eeprom unsigned long int eeprom_do_zameny_masla_imp;

eeprom unsigned long int eeprom_vlito_sred_ml;
eeprom unsigned long int eeprom_put_total_imp;

unsigned char rom_code[MAX_DEVICES][9]; 
float temp;
unsigned char i,j,devices;

float PrFors;   //   136.8 /  
unsigned long int imp_km;  //      

//   
unsigned long int  put_total_imp;
unsigned long int put_sred_m;
float  vlito_sred_ml;
float rashod_sred_l;
float  v_bake =0; //   

//     ,    ? :) 
//unsigned long int  vlito_mom_mks=0;
// ,   
float rashod_mom_l =0;
char speed=0;
//  
unsigned long int  put_start_imp=0;
unsigned long int overflov_count_rashod =0;  // 
unsigned int ostatok_tcnt1_rashod =0;  // 
 // float put_mom_m =0;

//  
char dl_vpr_count_overflov;
unsigned long int dlit_vpr =0;  // 
unsigned int overflov_count_vpr =0;  // 
unsigned int ostatok_tcnt1_vpr =0;  // 


//  ,     .
unsigned long int  do_zameny_grm_imp =0;  
unsigned long int  do_zameny_masla_imp =0;

//    
float ost_km = 0; //     v_bake    .
float sred_ost_km;
char ost_km_count;

float adc_data =0;

//    1 
unsigned int  time=0;
//unsigned long int  oferflov_timer_1 =0;  //     


float  v_bake_plus;
char displ_buffer[16];
char display_contrast=50; 
char display_brightness = 50;

char old_display_number=255;
bit temp_data_saved =0;
int sel_item;
unsigned char refresh_lcd_count;
char shim_counter;
float debag_data1;
float debag_data2;

// 
void refresh_display(void);
void kb(void);
void add_ost_km(float new_data);
void enable_drl(void);
void pik(char raz);
void save_temp_data(void);
void load_temp_data(void);
void load_defaults(void);
void my_f(void);
void calc_mom_rashod(void);

char flag_calc_mom_rashod =0;
char flag_refresh_display =0;
char flag_calculate_data =0;
//char display_number=DISP_DEBAG;
char display_number=DISP_MAIN_1;

//         
char calc_mom_rashod_worked = 0;
char refresh_display_worked = 0;